Angular Accordion Properties

An object defining configuration properties for the Accordion UI component.

accessKey

Specifies the shortcut key that sets focus on the UI component.

Type:

String

| undefined
Default Value: undefined

The value of this property will be passed to the accesskey attribute of the HTML element that underlies the UI component.

activeStateEnabled

Specifies whether the UI component changes its visual state as a result of user interaction.

Type:

Boolean

Default Value: false

The UI component switches to the active state when users press down the primary mouse button. When this property is set to true, the CSS rules for the active state apply. You can change these rules to customize the component.

Use this property when you display the component on a platform whose guidelines include the active state change for UI components.

animationDuration

A number specifying the time in milliseconds spent on the animation of the expanding or collapsing of a panel.

Type:

Number

Default Value: 300, 200 (Fluent, Material)

collapsible

Specifies whether all items can be collapsed or whether at least one item must always be expanded.

Type:

Boolean

Default Value: false

dataSource

Binds the UI component to data.

Default Value: null

The Accordion works with collections of string values or objects.

Depending on your data source, bind Accordion to data as follows. If the data source provides objects, also specify the itemTemplate. You can skip this part if the objects contain fields described in the items section.

  • Data Array
    Assign the array to the dataSource option.

  • Read-Only Data in JSON Format
    Set the dataSource property to the URL of a JSON file or service that returns JSON data.

  • OData
    Implement an ODataStore.

  • Web API, PHP, MongoDB
    Use one of the following extensions to enable the server to process data according to the protocol DevExtreme UI components use:

    Then, use the createStore method to configure access to the server on the client as shown below. This method is part of DevExtreme.AspNet.Data.

    app.component.ts
    app.component.html
    app.module.ts
    • import { Component } from '@angular/core';
    • import CustomStore from 'devextreme/data/custom_store';
    • import { createStore } from 'devextreme-aspnet-data-nojquery';
    •  
    • @Component({
    • selector: 'app-root',
    • templateUrl: './app.component.html',
    • styleUrls: ['./app.component.css']
    • })
    • export class AppComponent {
    • store: CustomStore;
    • constructor() {
    • let serviceUrl = "https://url/to/my/service";
    • this.store = createStore({
    • key: "ID",
    • loadUrl: serviceUrl + "/GetAction",
    • insertUrl: serviceUrl + "/InsertAction",
    • updateUrl: serviceUrl + "/UpdateAction",
    • deleteUrl: serviceUrl + "/DeleteAction"
    • })
    • }
    • }
    • <dx-accordion ...
    • [dataSource]="store">
    • </dx-accordion>
    • import { BrowserModule } from '@angular/platform-browser';
    • import { NgModule } from '@angular/core';
    • import { AppComponent } from './app.component';
    •  
    • import { DxAccordionModule } from 'devextreme-angular';
    •  
    • @NgModule({
    • declarations: [
    • AppComponent
    • ],
    • imports: [
    • BrowserModule,
    • DxAccordionModule
    • ],
    • providers: [],
    • bootstrap: [AppComponent]
    • })
    • export class AppModule { }
  • Any other data source
    Implement a CustomStore.

Regardless of the data source on the input, the Accordion always wraps it in the DataSource object. This object allows you to sort, filter, group, and perform other data shaping operations. To get its instance, call the getDataSource() method.

NOTE

Review the following notes about data binding:

  • Do not specify the items property if you specified the dataSource, and vice versa.

  • Data field names cannot be equal to this and should not contain the following characters: ., :, [, and ].

  • The stores are immutable. You cannot change their configurations at runtime. Instead, create a new store or DataSource and assign it to the dataSource property as shown in the following help topic: Two-Way Property Binding.

deferRendering

Specifies whether to render the panel's content when it is displayed. If false, the content is rendered immediately.

Type:

Boolean

Default Value: true

If you set the deferRendering property to true, wrap the content in the Angular named template.

disabled

Specifies whether the UI component responds to user interaction.

Type:

Boolean

Default Value: false

elementAttr

Specifies the global attributes to be attached to the UI component's container element.

Selector: dxo-element-attr
Type:

Object

Default Value: {}

HTML
TypeScript
  • <dx-accordion ...
  • [elementAttr]="{ id: 'elementId', class: 'class-name' }">
  • </dx-accordion>
  • import { DxAccordionModule } from "devextreme-angular";
  • // ...
  • export class AppComponent {
  • // ...
  • }
  • @NgModule({
  • imports: [
  • // ...
  • DxAccordionModule
  • ],
  • // ...
  • })

focusStateEnabled

Specifies whether the UI component can be focused using keyboard navigation.

Type:

Boolean

Default Value: true (desktop)

height

Specifies the UI component's height.

Type:

Number

|

String

|

Function

| undefined
Return Value:

Number

|

String

The UI component's height.

Default Value: undefined

This property accepts a value of one of the following types:

  • Number
    The height in pixels.

  • String
    A CSS-accepted measurement of height. For example, "55px", "20vh", "80%", "inherit".

  • Function (deprecated since v21.2)
    Refer to the W0017 warning description for information on how you can migrate to viewport units.

hint

Specifies text for a hint that appears when a user pauses on the UI component.

Type:

String

| undefined
Default Value: undefined

hoverStateEnabled

Specifies whether the UI component changes its state when a user pauses on it.

Type:

Boolean

Default Value: true

itemHoldTimeout

The time period in milliseconds before the onItemHold event is raised.

Type:

Number

Default Value: 750

items[]

An array of items displayed by the UI component.

Selector: dxi-item
Type:

Array<String | dxAccordionItem | any>

Raised Events: onOptionChanged

The items array can contain:

  • Strings
  • Objects with fields described in this section
  • Objects with any other fields. In this case, specify the itemTemplate.

If you need to update the UI component items, reassign the entire items array as shown in the following example:

JavaScript
  • accordionInstance.option('items', newItems);

As an alternative to items, you can use the dataSource property. It accepts the DataSource object, whose underlying stores provide an API that allows you to update individual items without reassigning the entire item collection.

NOTE
Do not use the items property if you use dataSource, and vice versa.

itemTemplate

Specifies a custom template for items.

Type:

template

Template Data:

Object

The current item's data.

Default Name: 'item'

itemTitleTemplate

Specifies a custom template for item titles.

Type:

template

Template Data:

Object

The current item's data.

Default Name: 'title'

keyExpr

Specifies the key property that provides key values to access data items. Each key value must be unique.

Type:

String

|

Function

Default Value: null

multiple

Specifies whether the UI component can expand several items or only a single item at once.

Type:

Boolean

Default Value: false

noDataText

Specifies the text or HTML markup displayed by the UI component if the item collection is empty.

Type:

String

Default Value: 'No data to display'

The Accordion component evaluates the noDataText property's value. This evaluation, however, makes the Accordion potentially vulnerable to XSS attacks. To guard against these attacks, encode the HTML markup before you assign it to the noDataText property. Refer to the following help topic for more information: Potentially Vulnerable API - noDataText.

onContentReady

A function that is executed when the UI component is rendered and each time the component is repainted.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onDisposing

A function that is executed before the UI component is disposed of.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onInitialized

A function used in JavaScript frameworks to save the UI component instance.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

app.component.html
app.component.ts
  • <dx-accordion ...
  • (onInitialized)="saveInstance($event)">
  • </dx-accordion>
  • import { Component } from "@angular/core";
  • import Accordion from "devextreme/ui/data_grid";
  • // ...
  • export class AppComponent {
  • accordionInstance: Accordion;
  • saveInstance (e) {
  • this.accordionInstance = e.component;
  • }
  • }
See Also
  • Get a UI component Instance in Angular

onItemClick

A function that is executed when a collection item is clicked or tapped.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The clicked item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The clicked item's data.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

element

HTMLElement | jQuery

The UI component's container.

component

Accordion

The UI component's instance.

Default Value: null

onItemContextMenu

A function that is executed when a collection item is right-clicked or pressed.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The item's data.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onItemHold

A function that is executed when a collection item has been held for a specified period.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The data of the item being held.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onItemRendered

A function that is executed after a collection item is rendered.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The current item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The current item's data.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onItemTitleClick

A function that is executed when an accordion item's title is clicked or tapped.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
component

Accordion

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

itemData

Object

The clicked item's data.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemIndex

Number

The clicked item's index.

Default Value: null

onOptionChanged

A function that is executed after a UI component property is changed.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
value any

The modified property's new value.

previousValue any

The UI component's previous value.

name

String

The modified property if it belongs to the first level. Otherwise, the first-level property it is nested into.

fullName

String

The path to the modified property that includes all parent properties.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

The following example shows how to subscribe to component property changes:

app.component.html
app.component.ts
app.module.ts
  • <dx-accordion ...
  • (onOptionChanged)="handlePropertyChange($event)">
  • </dx-accordion>
  • import { Component } from '@angular/core';
  •  
  • @Component({
  • selector: 'app-root',
  • templateUrl: './app.component.html',
  • styleUrls: ['./app.component.css']
  • })
  •  
  • export class AppComponent {
  • // ...
  • handlePropertyChange(e) {
  • if(e.name === "changedProperty") {
  • // handle the property change here
  • }
  • }
  • }
  • import { BrowserModule } from '@angular/platform-browser';
  • import { NgModule } from '@angular/core';
  • import { AppComponent } from './app.component';
  • import { DxAccordionModule } from 'devextreme-angular';
  •  
  • @NgModule({
  • declarations: [
  • AppComponent
  • ],
  • imports: [
  • BrowserModule,
  • DxAccordionModule
  • ],
  • providers: [ ],
  • bootstrap: [AppComponent]
  • })
  •  
  • export class AppModule { }

onSelectionChanged

A function that is executed when a collection item is selected or selection is canceled.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
removedItems

Array<any>

The data of the items removed from selection.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

addedItems

Array<any>

The data of the selected items.

Default Value: null

repaintChangesOnly

Specifies whether to repaint only those elements whose data changed.

Type:

Boolean

Default Value: false

See Also

rtlEnabled

Switches the UI component to a right-to-left representation.

Type:

Boolean

Default Value: false

When this property is set to true, the UI component text flows from right to left, and the layout of elements is reversed. To switch the entire application/site to the right-to-left representation, assign true to the rtlEnabled field of the object passed to the DevExpress.config(config) method.

JavaScript
  • DevExpress.config({
  • rtlEnabled: true
  • });

DataGrid Demo Navigation UI Demo Editors Demo

selectedIndex

The index number of the currently expanded item.

Type:

Number

Default Value: 0
Raised Events: onSelectionChanged

selectedItem

The expanded item object.

Type: any
Default Value: null
Raised Events: onSelectionChanged

selectedItemKeys

Specifies an array of currently expanded item keys.

Type:

Array<any>

Raised Events: onSelectionChanged

selectedItems

An array of currently expanded item objects.

Type:

Array<any>

Raised Events: onSelectionChanged

tabIndex

Specifies the number of the element when the Tab key is used for navigating.

Type:

Number

Default Value: 0

The value of this property will be passed to the tabindex attribute of the HTML element that underlies the UI component.

visible

Specifies whether the UI component is visible.

Type:

Boolean

Default Value: true

width

Specifies the UI component's width.

Type:

Number

|

String

|

Function

| undefined
Return Value:

Number

|

String

The UI component's width.

Default Value: undefined

This property accepts a value of one of the following types:

  • Number
    The width in pixels.

  • String
    A CSS-accepted measurement of width. For example, "55px", "20vw", "80%", "auto", "inherit".

  • Function (deprecated since v21.2)
    Refer to the W0017 warning description for information on how you can migrate to viewport units.

Vue Accordion Props

An object defining configuration properties for the Accordion UI component.

accessKey

Specifies the shortcut key that sets focus on the UI component.

Selector: access-key
Type:

String

| undefined
Default Value: undefined

The value of this property will be passed to the accesskey attribute of the HTML element that underlies the UI component.

activeStateEnabled

Specifies whether the UI component changes its visual state as a result of user interaction.

Selector: active-state-enabled
Type:

Boolean

Default Value: false

The UI component switches to the active state when users press down the primary mouse button. When this property is set to true, the CSS rules for the active state apply. You can change these rules to customize the component.

Use this property when you display the component on a platform whose guidelines include the active state change for UI components.

animationDuration

A number specifying the time in milliseconds spent on the animation of the expanding or collapsing of a panel.

Selector: animation-duration
Type:

Number

Default Value: 300, 200 (Fluent, Material)

collapsible

Specifies whether all items can be collapsed or whether at least one item must always be expanded.

Type:

Boolean

Default Value: false

dataSource

Binds the UI component to data.

Selector: data-source
Default Value: null

The Accordion works with collections of string values or objects.

Depending on your data source, bind Accordion to data as follows. If the data source provides objects, also specify the itemTemplate. You can skip this part if the objects contain fields described in the items section.

  • Data Array
    Assign the array to the dataSource option.

  • Read-Only Data in JSON Format
    Set the dataSource property to the URL of a JSON file or service that returns JSON data.

  • OData
    Implement an ODataStore.

  • Web API, PHP, MongoDB
    Use one of the following extensions to enable the server to process data according to the protocol DevExtreme UI components use:

    Then, use the createStore method to configure access to the server on the client as shown below. This method is part of DevExtreme.AspNet.Data.

    App.vue
    • <template>
    • <DxAccordion ...
    • :data-source="store" />
    • </template>
    •  
    • <script>
    • import 'devextreme/dist/css/dx.light.css';
    •  
    • import CustomStore from 'devextreme/data/custom_store';
    • import { createStore } from 'devextreme-aspnet-data-nojquery';
    • import { DxAccordion } from 'devextreme-vue/accordion';
    •  
    • export default {
    • components: {
    • DxAccordion
    • },
    • data() {
    • const serviceUrl = "https://url/to/my/service";
    • const store = createStore({
    • key: "ID",
    • loadUrl: serviceUrl + "/GetAction",
    • insertUrl: serviceUrl + "/InsertAction",
    • updateUrl: serviceUrl + "/UpdateAction",
    • deleteUrl: serviceUrl + "/DeleteAction"
    • });
    • return {
    • store
    • }
    • }
    • }
    • </script>
  • Any other data source
    Implement a CustomStore.

Regardless of the data source on the input, the Accordion always wraps it in the DataSource object. This object allows you to sort, filter, group, and perform other data shaping operations. To get its instance, call the getDataSource() method.

NOTE

Review the following notes about data binding:

  • Do not specify the items property if you specified the dataSource, and vice versa.

  • Data field names cannot be equal to this and should not contain the following characters: ., :, [, and ].

  • The stores are immutable. You cannot change their configurations at runtime. Instead, create a new store or DataSource and assign it to the dataSource property as shown in the following help topic: Two-Way Property Binding.

deferRendering

Specifies whether to render the panel's content when it is displayed. If false, the content is rendered immediately.

Selector: defer-rendering
Type:

Boolean

Default Value: true

If you set the deferRendering property to true, wrap the content in the Vue named template.

disabled

Specifies whether the UI component responds to user interaction.

Type:

Boolean

Default Value: false

elementAttr

Specifies the global attributes to be attached to the UI component's container element.

Selector: DxElementAttr
Type:

Object

Default Value: {}

App.vue
  • <template>
  • <DxAccordion ...
  • :element-attr="accordionAttributes">
  • </DxAccordion>
  • </template>
  •  
  • <script>
  • import DxAccordion from 'devextreme-vue/accordion';
  •  
  • export default {
  • components: {
  • DxAccordion
  • },
  • data() {
  • return {
  • accordionAttributes: {
  • id: 'elementId',
  • class: 'class-name'
  • }
  • }
  • }
  • }
  • </script>

focusStateEnabled

Specifies whether the UI component can be focused using keyboard navigation.

Selector: focus-state-enabled
Type:

Boolean

Default Value: true (desktop)

height

Specifies the UI component's height.

Type:

Number

|

String

|

Function

| undefined
Return Value:

Number

|

String

The UI component's height.

Default Value: undefined

This property accepts a value of one of the following types:

  • Number
    The height in pixels.

  • String
    A CSS-accepted measurement of height. For example, "55px", "20vh", "80%", "inherit".

  • Function (deprecated since v21.2)
    Refer to the W0017 warning description for information on how you can migrate to viewport units.

hint

Specifies text for a hint that appears when a user pauses on the UI component.

Type:

String

| undefined
Default Value: undefined

hoverStateEnabled

Specifies whether the UI component changes its state when a user pauses on it.

Selector: hover-state-enabled
Type:

Boolean

Default Value: true

itemHoldTimeout

The time period in milliseconds before the onItemHold event is raised.

Selector: item-hold-timeout
Type:

Number

Default Value: 750

items[]

An array of items displayed by the UI component.

Selector: DxItem
Type:

Array<String | dxAccordionItem | any>

Raised Events: onOptionChanged

The items array can contain:

  • Strings
  • Objects with fields described in this section
  • Objects with any other fields. In this case, specify the itemTemplate.

If you need to update the UI component items, reassign the entire items array as shown in the following example:

JavaScript
  • accordionInstance.option('items', newItems);

As an alternative to items, you can use the dataSource property. It accepts the DataSource object, whose underlying stores provide an API that allows you to update individual items without reassigning the entire item collection.

NOTE
Do not use the items property if you use dataSource, and vice versa.

itemTemplate

Specifies a custom template for items.

Selector: item-template
Type:

template

Template Data:

Object

The current item's data.

Default Name: 'item'

itemTitleTemplate

Specifies a custom template for item titles.

Selector: item-title-template
Type:

template

Template Data:

Object

The current item's data.

Default Name: 'title'

keyExpr

Specifies the key property that provides key values to access data items. Each key value must be unique.

Selector: key-expr
Type:

String

|

Function

Default Value: null

multiple

Specifies whether the UI component can expand several items or only a single item at once.

Type:

Boolean

Default Value: false

noDataText

Specifies the text or HTML markup displayed by the UI component if the item collection is empty.

Selector: no-data-text
Type:

String

Default Value: 'No data to display'

The Accordion component evaluates the noDataText property's value. This evaluation, however, makes the Accordion potentially vulnerable to XSS attacks. To guard against these attacks, encode the HTML markup before you assign it to the noDataText property. Refer to the following help topic for more information: Potentially Vulnerable API - noDataText.

onContentReady

A function that is executed when the UI component is rendered and each time the component is repainted.

Selector: @content-ready
Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onDisposing

A function that is executed before the UI component is disposed of.

Selector: @disposing
Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onInitialized

A function used in JavaScript frameworks to save the UI component instance.

Selector: @initialized
Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

App.vue (Options API)
App.vue (Composition API)
  • <template>
  • <div>
  • <DxAccordion ...
  • @initialized="saveInstance">
  • </DxAccordion>
  • </div>
  • </template>
  •  
  • <script>
  • import DxAccordion from 'devextreme-vue/accordion';
  •  
  • export default {
  • components: {
  • DxAccordion
  • },
  • data: function() {
  • return {
  • accordionInstance: null
  • };
  • },
  • methods: {
  • saveInstance: function(e) {
  • this.accordionInstance = e.component;
  • }
  • }
  • };
  • </script>
  • <template>
  • <div>
  • <DxAccordion ...
  • @initialized="saveInstance">
  • </DxAccordion>
  • </div>
  • </template>
  •  
  • <script setup>
  • import DxAccordion from 'devextreme-vue/accordion';
  •  
  • let accordionInstance = null;
  •  
  • const saveInstance = (e) => {
  • accordionInstance = e.component;
  • }
  • </script>
See Also
  • Get a UI component Instance in Vue

onItemClick

A function that is executed when a collection item is clicked or tapped.

Selector: @item-click
Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The clicked item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The clicked item's data.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

element

HTMLElement | jQuery

The UI component's container.

component

Accordion

The UI component's instance.

Default Value: null

onItemContextMenu

A function that is executed when a collection item is right-clicked or pressed.

Selector: @item-context-menu
Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The item's data.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onItemHold

A function that is executed when a collection item has been held for a specified period.

Selector: @item-hold
Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The data of the item being held.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onItemRendered

A function that is executed after a collection item is rendered.

Selector: @item-rendered
Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The current item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The current item's data.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onItemTitleClick

A function that is executed when an accordion item's title is clicked or tapped.

Selector: @item-title-click
Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
component

Accordion

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

itemData

Object

The clicked item's data.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemIndex

Number

The clicked item's index.

Default Value: null

onOptionChanged

A function that is executed after a UI component property is changed.

Selector: @option-changed
Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
value any

The modified property's new value.

previousValue any

The UI component's previous value.

name

String

The modified property if it belongs to the first level. Otherwise, the first-level property it is nested into.

fullName

String

The path to the modified property that includes all parent properties.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

The following example shows how to subscribe to component property changes:

App.vue
  • <template>
  • <DxAccordion ...
  • @option-changed="handlePropertyChange"
  • />
  • </template>
  •  
  • <script>
  • import 'devextreme/dist/css/dx.light.css';
  • import DxAccordion from 'devextreme-vue/accordion';
  •  
  • export default {
  • components: {
  • DxAccordion
  • },
  • // ...
  • methods: {
  • handlePropertyChange: function(e) {
  • if(e.name === "changedProperty") {
  • // handle the property change here
  • }
  • }
  • }
  • }
  • </script>

onSelectionChanged

A function that is executed when a collection item is selected or selection is canceled.

Selector: @selection-changed
Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
removedItems

Array<any>

The data of the items removed from selection.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

addedItems

Array<any>

The data of the selected items.

Default Value: null

repaintChangesOnly

Specifies whether to repaint only those elements whose data changed.

Selector: repaint-changes-only
Type:

Boolean

Default Value: false

See Also

rtlEnabled

Switches the UI component to a right-to-left representation.

Selector: rtl-enabled
Type:

Boolean

Default Value: false

When this property is set to true, the UI component text flows from right to left, and the layout of elements is reversed. To switch the entire application/site to the right-to-left representation, assign true to the rtlEnabled field of the object passed to the DevExpress.config(config) method.

JavaScript
  • DevExpress.config({
  • rtlEnabled: true
  • });

DataGrid Demo Navigation UI Demo Editors Demo

selectedIndex

The index number of the currently expanded item.

Selector: selected-index
Type:

Number

Default Value: 0
Raised Events: onSelectionChanged

selectedItem

The expanded item object.

Selector: selected-item
Type: any
Default Value: null
Raised Events: onSelectionChanged

selectedItemKeys

Specifies an array of currently expanded item keys.

Selector: selected-item-keys
Type:

Array<any>

Raised Events: onSelectionChanged

selectedItems

An array of currently expanded item objects.

Selector: selected-items
Type:

Array<any>

Raised Events: onSelectionChanged

tabIndex

Specifies the number of the element when the Tab key is used for navigating.

Selector: tab-index
Type:

Number

Default Value: 0

The value of this property will be passed to the tabindex attribute of the HTML element that underlies the UI component.

visible

Specifies whether the UI component is visible.

Type:

Boolean

Default Value: true

width

Specifies the UI component's width.

Type:

Number

|

String

|

Function

| undefined
Return Value:

Number

|

String

The UI component's width.

Default Value: undefined

This property accepts a value of one of the following types:

  • Number
    The width in pixels.

  • String
    A CSS-accepted measurement of width. For example, "55px", "20vw", "80%", "auto", "inherit".

  • Function (deprecated since v21.2)
    Refer to the W0017 warning description for information on how you can migrate to viewport units.

React Accordion Props

An object defining configuration properties for the Accordion UI component.

accessKey

Specifies the shortcut key that sets focus on the UI component.

Type:

String

| undefined
Default Value: undefined

The value of this property will be passed to the accesskey attribute of the HTML element that underlies the UI component.

activeStateEnabled

Specifies whether the UI component changes its visual state as a result of user interaction.

Type:

Boolean

Default Value: false

The UI component switches to the active state when users press down the primary mouse button. When this property is set to true, the CSS rules for the active state apply. You can change these rules to customize the component.

Use this property when you display the component on a platform whose guidelines include the active state change for UI components.

animationDuration

A number specifying the time in milliseconds spent on the animation of the expanding or collapsing of a panel.

Type:

Number

Default Value: 300, 200 (Fluent, Material)

collapsible

Specifies whether all items can be collapsed or whether at least one item must always be expanded.

Type:

Boolean

Default Value: false

dataSource

Binds the UI component to data.

Default Value: null

The Accordion works with collections of string values or objects.

Depending on your data source, bind Accordion to data as follows. If the data source provides objects, also specify the itemTemplate. You can skip this part if the objects contain fields described in the items section.

  • Data Array
    Assign the array to the dataSource option.

  • Read-Only Data in JSON Format
    Set the dataSource property to the URL of a JSON file or service that returns JSON data.

  • OData
    Implement an ODataStore.

  • Web API, PHP, MongoDB
    Use one of the following extensions to enable the server to process data according to the protocol DevExtreme UI components use:

    Then, use the createStore method to configure access to the server on the client as shown below. This method is part of DevExtreme.AspNet.Data.

    App.js
    • import React from 'react';
    • import 'devextreme/dist/css/dx.light.css';
    •  
    • import CustomStore from 'devextreme/data/custom_store';
    • import { createStore } from 'devextreme-aspnet-data-nojquery';
    • import Accordion from 'devextreme-react/accordion';
    •  
    • const serviceUrl = "https://url/to/my/service";
    • const store = createStore({
    • key: "ID",
    • loadUrl: serviceUrl + "/GetAction",
    • insertUrl: serviceUrl + "/InsertAction",
    • updateUrl: serviceUrl + "/UpdateAction",
    • deleteUrl: serviceUrl + "/DeleteAction"
    • });
    •  
    • class App extends React.Component {
    • render() {
    • return (
    • <Accordion ...
    • dataSource={store} />
    • );
    • }
    • }
    • export default App;
  • Any other data source
    Implement a CustomStore.

Regardless of the data source on the input, the Accordion always wraps it in the DataSource object. This object allows you to sort, filter, group, and perform other data shaping operations. To get its instance, call the getDataSource() method.

NOTE

Review the following notes about data binding:

  • Do not specify the items property if you specified the dataSource, and vice versa.

  • Data field names cannot be equal to this and should not contain the following characters: ., :, [, and ].

  • The stores are immutable. You cannot change their configurations at runtime. Instead, create a new store or DataSource and assign it to the dataSource property as shown in the following help topic: Controlled Mode.

deferRendering

Specifies whether to render the panel's content when it is displayed. If false, the content is rendered immediately.

Type:

Boolean

Default Value: true

disabled

Specifies whether the UI component responds to user interaction.

Type:

Boolean

Default Value: false

elementAttr

Specifies the global attributes to be attached to the UI component's container element.

Selector: ElementAttr
Type:

Object

Default Value: {}

App.js
  • import React from 'react';
  •  
  • import Accordion from 'devextreme-react/accordion';
  •  
  • class App extends React.Component {
  • accordionAttributes = {
  • id: 'elementId',
  • class: 'class-name'
  • }
  •  
  • render() {
  • return (
  • <Accordion ...
  • elementAttr={this.accordionAttributes}>
  • </Accordion>
  • );
  • }
  • }
  • export default App;

focusStateEnabled

Specifies whether the UI component can be focused using keyboard navigation.

Type:

Boolean

Default Value: true (desktop)

height

Specifies the UI component's height.

Type:

Number

|

String

|

Function

| undefined
Return Value:

Number

|

String

The UI component's height.

Default Value: undefined

This property accepts a value of one of the following types:

  • Number
    The height in pixels.

  • String
    A CSS-accepted measurement of height. For example, "55px", "20vh", "80%", "inherit".

  • Function (deprecated since v21.2)
    Refer to the W0017 warning description for information on how you can migrate to viewport units.

hint

Specifies text for a hint that appears when a user pauses on the UI component.

Type:

String

| undefined
Default Value: undefined

hoverStateEnabled

Specifies whether the UI component changes its state when a user pauses on it.

Type:

Boolean

Default Value: true

itemComponent

An alias for the itemTemplate property specified in React. Accepts a custom component. Refer to Using a Custom Component for more information.

itemHoldTimeout

The time period in milliseconds before the onItemHold event is raised.

Type:

Number

Default Value: 750

itemRender

An alias for the itemTemplate property specified in React. Accepts a rendering function. Refer to Using a Rendering Function for more information.

items[]

An array of items displayed by the UI component.

Selector: Item
Type:

Array<String | dxAccordionItem | any>

Raised Events: onOptionChanged

The items array can contain:

  • Strings
  • Objects with fields described in this section
  • Objects with any other fields. In this case, specify the itemTemplate.

If you need to update the UI component items, reassign the entire items array as shown in the following example:

JavaScript
  • accordionInstance.option('items', newItems);

As an alternative to items, you can use the dataSource property. It accepts the DataSource object, whose underlying stores provide an API that allows you to update individual items without reassigning the entire item collection.

NOTE
Do not use the items property if you use dataSource, and vice versa.

itemTemplate

Specifies a custom template for items.

Type:

template

Template Data:

Object

The current item's data.

Default Name: 'item'

itemTitleComponent

An alias for the itemTitleTemplate property specified in React. Accepts a custom component. Refer to Using a Custom Component for more information.

itemTitleRender

An alias for the itemTitleTemplate property specified in React. Accepts a rendering function. Refer to Using a Rendering Function for more information.

itemTitleTemplate

Specifies a custom template for item titles.

Type:

template

Template Data:

Object

The current item's data.

Default Name: 'title'

keyExpr

Specifies the key property that provides key values to access data items. Each key value must be unique.

Type:

String

|

Function

Default Value: null

multiple

Specifies whether the UI component can expand several items or only a single item at once.

Type:

Boolean

Default Value: false

noDataText

Specifies the text or HTML markup displayed by the UI component if the item collection is empty.

Type:

String

Default Value: 'No data to display'

The Accordion component evaluates the noDataText property's value. This evaluation, however, makes the Accordion potentially vulnerable to XSS attacks. To guard against these attacks, encode the HTML markup before you assign it to the noDataText property. Refer to the following help topic for more information: Potentially Vulnerable API - noDataText.

onContentReady

A function that is executed when the UI component is rendered and each time the component is repainted.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onDisposing

A function that is executed before the UI component is disposed of.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onInitialized

A function used in JavaScript frameworks to save the UI component instance.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

App.js
  • import Accordion from 'devextreme-react/accordion';
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.saveInstance = this.saveInstance.bind(this);
  • }
  •  
  • saveInstance(e) {
  • this.accordionInstance = e.component;
  • }
  •  
  • render() {
  • return (
  • <div>
  • <Accordion onInitialized={this.saveInstance} />
  • </div>
  • );
  • }
  • }
See Also
  • Get a UI component Instance in React

onItemClick

A function that is executed when a collection item is clicked or tapped.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The clicked item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The clicked item's data.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

element

HTMLElement | jQuery

The UI component's container.

component

Accordion

The UI component's instance.

Default Value: null

onItemContextMenu

A function that is executed when a collection item is right-clicked or pressed.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The item's data.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onItemHold

A function that is executed when a collection item has been held for a specified period.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The data of the item being held.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onItemRendered

A function that is executed after a collection item is rendered.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
itemIndex

Number

The current item's index.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemData

Object

The current item's data.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

onItemTitleClick

A function that is executed when an accordion item's title is clicked or tapped.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
component

Accordion

The UI component's instance.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

event

Event (jQuery or EventObject)

The event that caused the function to execute. It is an EventObject or a jQuery.Event when you use jQuery.

itemData

Object

The clicked item's data.

itemElement

HTMLElement | jQuery

The item's container. It is an HTML Element or a jQuery Element when you use jQuery.

itemIndex

Number

The clicked item's index.

Default Value: null

onOptionChanged

A function that is executed after a UI component property is changed.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
value any

The modified property's new value.

previousValue any

The UI component's previous value.

name

String

The modified property if it belongs to the first level. Otherwise, the first-level property it is nested into.

fullName

String

The path to the modified property that includes all parent properties.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

Default Value: null

The following example shows how to subscribe to component property changes:

App.js
  • import React from 'react';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import Accordion from 'devextreme-react/accordion';
  •  
  • const handlePropertyChange = (e) => {
  • if(e.name === "changedProperty") {
  • // handle the property change here
  • }
  • }
  •  
  • export default function App() {
  • return (
  • <Accordion ...
  • onOptionChanged={handlePropertyChange}
  • />
  • );
  • }

onSelectionChanged

A function that is executed when a collection item is selected or selection is canceled.

Type:

Function

Function parameters:

Information about the event.

Object structure:
Name Type Description
removedItems

Array<any>

The data of the items removed from selection.

element

HTMLElement | jQuery

The UI component's container. It is an HTML Element or a jQuery Element when you use jQuery.

component

Accordion

The UI component's instance.

addedItems

Array<any>

The data of the selected items.

Default Value: null

repaintChangesOnly

Specifies whether to repaint only those elements whose data changed.

Type:

Boolean

Default Value: false

See Also

rtlEnabled

Switches the UI component to a right-to-left representation.

Type:

Boolean

Default Value: false

When this property is set to true, the UI component text flows from right to left, and the layout of elements is reversed. To switch the entire application/site to the right-to-left representation, assign true to the rtlEnabled field of the object passed to the DevExpress.config(config) method.

JavaScript
  • DevExpress.config({
  • rtlEnabled: true
  • });

DataGrid Demo Navigation UI Demo Editors Demo

selectedIndex

The index number of the currently expanded item.

Type:

Number

Default Value: 0
Raised Events: onSelectionChanged

selectedItem

The expanded item object.

Type: any
Default Value: null
Raised Events: onSelectionChanged

selectedItemKeys

Specifies an array of currently expanded item keys.

Type:

Array<any>

Raised Events: onSelectionChanged

selectedItems

An array of currently expanded item objects.

Type:

Array<any>

Raised Events: onSelectionChanged

tabIndex

Specifies the number of the element when the Tab key is used for navigating.

Type:

Number

Default Value: 0

The value of this property will be passed to the tabindex attribute of the HTML element that underlies the UI component.

visible

Specifies whether the UI component is visible.

Type:

Boolean

Default Value: true

width

Specifies the UI component's width.

Type:

Number

|

String

|

Function

| undefined
Return Value:

Number

|

String

The UI component's width.

Default Value: undefined

This property accepts a value of one of the following types:

  • Number
    The width in pixels.

  • String
    A CSS-accepted measurement of width. For example, "55px", "20vw", "80%", "auto", "inherit".

  • Function (deprecated since v21.2)
    Refer to the W0017 warning description for information on how you can migrate to viewport units.